/*jslint nomen: true, indent: 2, maxerr: 3 */
/*global window, rJS, Handlebars, document, loopEventListener, RSVP */
(function (window, rJS, document, RSVP) {
  "use strict";

  rJS(window)
    /////////////////////////////////////////////////////////////////
    // ready
    /////////////////////////////////////////////////////////////////

    // Assign the element to a variable
    .ready(function (g) {
      g.props = {};
      return g.getElement()
        .push(function (element) {
          g.props.element = element;
        });
    })
    //////////////////////////////////////////////
    // acquired methods
    //////////////////////////////////////////////
    .declareAcquiredMethod("getUrlFor", "getUrlFor")
    .declareMethod('render', function (options) {
      var gadget = this,
        page_list = ["jslint", "mass_remove"],
        promise_list = [];

      page_list.forEach(function (page) {
        promise_list.push(gadget.getUrlFor({page: page}));
      });
      // Handle main title
      return new RSVP.Queue()
        .push(function () {
          return RSVP.all(promise_list);
        })
        .push(function (link_list) {
          for (var i = 0; i < link_list.length; i++) {
            gadget.props.element.querySelector("." + page_list[i]).href = link_list[i];
          }
        });
    });


}(window, rJS, document, RSVP));